﻿@using ChartJs.Blazor.Charts
@using ChartJs.Blazor.ChartJS.PieChart
@using ChartJs.Blazor.ChartJS.Common.Properties
@using ChartJs.Blazor.Util

<div>
    <div>
        <ChartJsPieChart @ref="_pieChartJs" Config="@_config" Width="@ChartWidth" Height="@ChartHeigth" />
        <div class="alert-info" style="display:@noDataValue">
            <center>
                <label>No Records Found</label>
            </center>
        </div>
    </div>
</div>



@code {
    private PieConfig _config;
    private ChartJsPieChart _pieChartJs;
    private string noDataValue = "none";

    [Parameter]
    public int ChartWidth { get; set; } = 700;
    [Parameter]
    public int ChartHeigth { get; set; } = 1000;
    [Parameter]
    public bool IsDisplayTitle { get; set; } = true;
    [Parameter]
    public string ChartTitle { get; set; } = "";
    [Parameter]
    public bool IsResponsive { get; set; } = true;
    [Parameter]
    public bool IsAnimateRotate { get; set; } = true;
    [Parameter]
    public bool IsAnimateScale { get; set; } = true;
    [Parameter]
    public List<ChartDataItem> ChartDataList { get; set; }
    [Parameter]
    public int BorderWidth { get; set; } = 0;
    [Parameter]
    public string BorderColor { get; set; } = "#ffffff";
    [Parameter]
    public int HoverBorderWidth { get; set; } = 1;
    [Parameter]
    public string HoverBorderColor { get; set; } = ColorUtil.RandomColorString();
    [Parameter]
    public string HoverBackgroundColor { get; set; } = ColorUtil.RandomColorString();


    protected override void OnInitialized()
    {
        _config = new PieConfig
        {
            Options = new PieOptions
            {
                Title = new OptionsTitle
                {
                    Display = this.IsDisplayTitle,
                    Text = this.ChartTitle
                },
                Responsive = this.IsResponsive,
                Animation = new ArcAnimation
                {
                    AnimateRotate = this.IsAnimateRotate,
                    AnimateScale = this.IsAnimateScale
                }
            }
        };

        PieDataset pieDataset = new PieDataset();

        _config.Data.Labels.AddRange(ChartDataList.Select(x => x.LabelName).ToArray());

        var pieSet = new PieDataset
        {
            BackgroundColor = ChartDataList.Select(x => ColorUtil.FromDrawingColor(x.Color)).ToArray(),
            BorderWidth = this.BorderWidth,
            HoverBackgroundColor = this.HoverBackgroundColor,
            HoverBorderColor = this.HoverBorderColor,
            HoverBorderWidth = this.HoverBorderWidth,
            BorderColor = this.BorderColor,

        };

        pieSet.Data.AddRange(ChartDataList.Select(x => x.Value).ToArray());
        _config.Data.Datasets.Add(pieSet);

        if(pieSet.Data.Sum() <= 0)
        {
            noDataValue = "block";
        }
        else
        {
            noDataValue = "none";
        }
        StateHasChanged();
    }

}
